clear variables 
close all

%calcolo potenziale di membrana FES
%libro + articolo di riferimento 

% no resistenza giunzionale

l=125e-6; %lunghezza miocita
rm=7.5e-6; %raggio miocita
ncells=1200;% numero di miociti fibra equaivalente
L=ncells*l; % lunghezza fibra equivalente
lambda= 5.2*l; %costante spazio
Ia=0.05e-6;  % corrente fibra equivalente
Ro=1.14e6/(125e-6); % resistenza assiale esterna
Ri=1.98e6/(125e-6); % resistenza assiale interna
x=-L/2:5e-6:+L/2; 

Ii=Ia*((Ro/(Ro+Ri))-(Ro/(Ro+Ri))*(cosh(x/lambda)/cosh(L/(2*lambda)))); %corrente assiale  interna 
Io=Ia*((Ri/(Ro+Ri))+(Ro/(Ro+Ri))*(cosh(x/lambda)/cosh(L/(2*lambda)))); %corrente aasiale esterna

Vm=((Ia*Ro*lambda)/(cosh(L/(2*lambda))))*sinh(x/lambda); % potenziale di membrana non considerndo le Resitenz giunzionali

figure 
plot(x,Vm)
legend('Vm');

figure
plot(x,Ii)
hold on 
plot(x,Io)
legend('Ii','Io');

% resistenza giunzionale 

x1=-l/2:5e-6:+l/2;

Rj= 1.5*(1e-2)^2/(pi*rm^2); %resistenza giunzionale

Vm1=((Ia*Ro*Rj)/(2*(Ro+Ri+Rj/l)*sinh(l/(2*lambda))))*sinh(x1/lambda); %potenziale sul singolo miocita supposto periodico 
figure 
plot(x1,Vm1)



% ripetizioni su fibre adiacenti
nrep=5


X1=[]; VM1=[];
for i=1:nrep
    X1=[X1 x1+(i-1)*l] ;
    VM1=[VM1 Vm1];
    
end

figure 
plot(X1,VM1)

%cellula iper polarizzata lambda1=lambda/10 (rm ridotto di due ordini di
%grandezza)

lambda1=lambda/10;

Vm2=((Ia*Ro*Rj)/(2*(Ro+Ri+Rj/l)*sinh(l/(2*lambda1))))*sinh(x1/lambda1);

X1=[]; VM2=[];
for i=1:nrep
    X1=[X1 x1+(i-1)*l] ;
    VM2=[VM2 Vm2];
    
end

figure(4)
hold on
plot(X1,VM2)
legend('sotto soglia','sopra soglia');











